// ======================================================
// CBP_3402_R_Camera_Investigate
// 15-10-21
// Simple sketch to return image parameters of one blob
// Based on:
// FBO_CBP_Calibrate_Camera.ino
// FB0 CBP 13-07021
// CBP Mod 14-07-21
// ======================================================

#include <Pixy2.h>
#include <Servo.h>

// Define pins --------------------------------
#define ServoL_pin 13
#define ServoR_pin 12
#define ServoTurret_pin 11

// Define constants ---------------------------
#define DEBUG true
#define wheelDiam 66.0
#define wheelRad (wheelDiam/2.0)
#define axleLen 104.0

// Global variables ---------------------------
Servo servoL;
Servo servoR; 
Servo servoTurret;

float driveL, driveR;

// This is the main Pixy object 
Pixy2 pixy;

// Pixy variables for this sketch -------------
uint16_t width;
uint16_t height;
uint16_t color;
uint8_t index;
uint8_t x;
uint8_t y;

int offset;

void setup() {  // ==== This runs once ========
  Serial.begin(9600);
  cprintf(">>> Initializing stuff ..................\n");
  Serial.begin(9600);
  Serial.print("Starting...\n");

  // Make sure camera is pointing forwards.  
  // Apply your offset here
  offset = 0;
  servoTurret.attach(ServoTurret_pin);
  for(int angle = 0; angle < 180; angle++){
    servoTurret.write(angle + offset);
    delay(10);
  }
  // Now set it to 90 degs pointing forwards
  servoTurret.write(90 + offset);
  delay(1000);
  servoTurret.detach();

  // Init the camera
  pixy.init();

  cprintf(">>> Pausing 2 secs ......................\n");
  delay(2000);
  cprintf(">>> Starting  ...........................\n"); 

}

void loop() {

  // Now get a single block
  pixy.ccc.getBlocks(true,1,1);

  // Only do stuff if we have detected a block ------
  if (pixy.ccc.numBlocks > 0) {
    x = pixy.ccc.blocks[0].m_x;
    y = pixy.ccc.blocks[0].m_y;
    cprintf("x = %d, y = %d\n",x,y);   
  }
  
}
