// ========================================================
//
// CBP_3402_R_Line_Follower
// 01-11-21
// Based on FBO_CBP_Line_Follower.ino
// FBO CBP 20-07-21
// Line following using Pixy2
//
// ========================================================

#include <Pixy2.h>
#include <Servo.h>                           

// Define pins ----------------------
#define ServoL_pin 13
#define ServoR_pin 12

// Global variables -----------------
Servo servoL;                                
Servo servoR;
float driveL;
float driveR;

// Globals for this task ------------
float error;
float lastError;
float deriv;
float Kp;
float Kd;
int fwd;

// PixyCam stuff -------------------
// This is the main Pixy object 
Pixy2 pixy;
uint8_t x0;
uint8_t y0;
uint16_t frameWidth;
uint16_t frameHeight;

void setup(){
  Serial.begin(9600); 
  cprintf(">>> Initializing stuff ..................\n"); 
  cprintf(">>> Pausing 2 secs ......................\n");
  delay(2000);
  cprintf(">>> Starting  ...........................\n");
  servoL.attach(ServoL_pin);
  servoR.attach(ServoR_pin);

  pixy.init();
  // Change to line tracking program
  pixy.changeProg("line");
  pixy.getResolution();
  frameWidth = pixy.frameWidth;
  frameHeight = pixy.frameHeight;
  cprintf("frameWidth = %d, frameHeight = %d\n",
          frameWidth,frameHeight);
          
  pixy.setLamp(1,0);

  // Tune the PID --------------------------------------
  fwd = 20;  Kp = 50;  Kd = 0;
  
}

// This code repeats indefinitely
void loop() {

  pixy.line.getAllFeatures();

  x0 = pixy.line.vectors[0].m_x0;

  // Add code to calc the error. Typecast ints to floats


  // Normalize the error


  // Calc the error derivative
  deriv = error - lastError;
  lastError = error;
  
  cprintf("x0 = %d, y0 = %d, error = %f, deriv = %f\n",
          x0,y0,error,deriv);

  // Calculate left and right drives
  // driveL = 
  // driveR = 

  // Drive the servos
  driveServos(driveL,driveR);

  // Add a delay while debugging using the Serial Monitor
  //delay(250);
                          
}

void driveServos(float _driveL, float _driveR) {
  servoL.writeMicroseconds(1500 + (int)_driveL);
  servoR.writeMicroseconds(1500 - (int)_driveR);
}
