// ========================================================
//
// CBP_3402_R_Rotate_Calibrate
// Rotating with some basic math calcs
// CBP 11-10-21 
// Status Release
//
// ========================================================

#include <stdio.h>
#include <Servo.h>

// Define pins ---------------
#define ServoL_pin 13
#define ServoR_pin 12

// Define constants ----------
#define dT 20
#define DEBUG true
#define wheelDiam 66.0
#define wheelRad (wheelDiam/2.0)
#define axleLen 104.0

// Global variables ----------
Servo servoL;
Servo servoR; 
float driveL, driveR;

void setup() {

  // Local variables
  float desDegrees;
  float desTheta;
  float desSpeed;
  float desTime;
  float omegaRobot;
  float omega;
  float rpm;
  int delayTime;
  
  Serial.begin(9600);
  Serial.println(">>> Initializing stuff ..................\n");  
  delay(1000);

  servoL.attach(ServoL_pin);
  servoR.attach(ServoR_pin);
  // Stop any servo movement
  driveServos(0.0,0.0);  

  cprintf(">>> Pausing 2 secs ......................\n");
  delay(2000);
  cprintf(">>> Starting  ...........................\n");
  
  // Start writing your code here --------------------------
  // Follow the worksheet flowchart

  // Choose your desired angle
  // desDegrees =
  // Uncomment the conversion below
  // desTheta = desDegrees*(PI/180.0);
  // Choose your desired time
  // desTime = 
  // Calculate the robot angular speed
  // omegaRobot = 
  // Calculate the wheel angular velocity ..
  // omega = 

  //correcton to omega goes here
  
  // Now the rpm to get the drive drive from the graph
  rpm = (60/(2*PI))*omega; 
  driveR = (50.0/30.0)*rpm; // from graph 
  // drive wheels in opposite direction
  driveL = -driveR;

  // End of your code. ----------------------------------------------
  
  cprintf("desDegrees = %f, desTime = %f\n",desDegrees,desTime);
  cprintf("desOmegaR = %f (mm/s), omega = %f (rad/s) rpm = %f driveL = %f\n",omegaRobot,omega,rpm,driveL);
  
  //Serial.println("Pausing 2 secs ......................");
  cprintf(">>> Pausing 2 secs ......................\n");
  delay(2000);
  cprintf(">>> Starting  ...........................\n");

  // Apply driveL and driveR for desTime
  driveServos(driveL,driveR);

  delayTime = (int)(desTime*1000);
  cprintf("DelayTime = %d\n",delayTime);
  delay(delayTime);

  // Stop any servo movement
  driveServos(0.0,0.0);  
  
}

void loop() {

}

void driveServos(float _driveL, float _driveR) {
  servoL.writeMicroseconds(1500 + (int)_driveL);
  servoR.writeMicroseconds(1500 - (int)_driveR);
}
