// =========================================================
// CBP_3402_D_Turret_Tweak
// From CBP_FBO Snake_Angle_Tweak Oct 2021.
// Zeros the PixyCam turret
// =========================================================

#include <Servo.h>                           

// Define pins ---------------
#define ServoL_pin 13
#define ServoR_pin 12
#define EncoderL_pin 19
#define EncoderR_pin 20
#define ServoTurret_pin 11

// Define constants ----------
#define DEBUG true
#define wheelDiam 66.0
#define wheelRad (wheelDiam/2.0)
#define axleLen 104.0
#define dx ((PI*wheelDiam)/64.0)


// Global variables ----------
Servo myServos[2];
Servo servoTurret;
int offset;


void setup() {
  Serial.begin(9600);
  cprintf(">>> Initializing stuff ..................\n"); 
  servoTurret.attach(ServoTurret_pin);
  servoTurret.write(90);
  cprintf(">>> Pausing 2 secs ......................\n");
  delay(2000);
  cprintf(">>> Starting  ...........................\n");
         
}



void loop(){  
  int index;
  if(Serial.available()) {
    char ch = (char)Serial.read();

    if(ch == 43) {
      offset += 1;
      servoTurret.write(90 + offset);
      delay(15);       
      Serial.print("Offset = ");
      Serial.println(offset);      
    }
    if(ch == 45) {
      offset -= 1;      
      servoTurret.write(90 + offset);
      delay(15);       
      Serial.print("Offset = ");
      Serial.println(offset);      
    }
     if(ch == 42) {  
      // rotate to 180 deg
      for(int i=90; i < 180;i++) {
        servoTurret.write(i + offset);
        delay(20);   
      }
      // rotate to 0 deg
      for(int i=180; i > 0;i--) {
        servoTurret.write(i + offset);
        delay(20);   
      }
      // back to centre 90 deg
      for(int i=0; i <= 90;i++) {
        servoTurret.write(i + offset);
        delay(20);   
      }     
    }

  }

  delay(500);
}
